''P1V Instructio set expansion
''Ozpropdev - Oct 2014

con

  sys_clk = 80_000_000

  _clkmode = xtal1 + pll16x
  _clkfreq = sys_clk

  tx_pin = 30,baudrate = 1200
  
pub demo

  coginit(0,@pasm,0)

    
dat pasm_code
                        org

pasm                    or        dira,tx
                        or        outa,tx

                        mov       ax,cnt
                        add       ax,_10secs
                        waitcnt   ax,0          'wait 10 secs for PST

                        mov       fx,test_value
                        call      #show_long    'show test value

'TEST of group2a  (standrd MUL,MULS,ENC,ONES opcodes)
'=======================================================================

'eswap8
'-------
'Endian swap bytes in destination

                        mul     fx,test_value 
                        call    #show_long

'eswap4
'------
'Endian swap nibbles in destination

                        muls    fx,test_value
                        call    #show_long

'eswap48
'-------
'Swap nibbles in bytes

                        enc    fx,test_value
                        call    #show_long

'bin2gry
'-------
'Convert 8 bit binary to 8 bit gray code

                        ones   fx,test_value
                        call    #show_long


'TEST of group2b
'=======================================================================

'n2a (nibble to ascii hex)
'---                        
        if_never        mul     fx,test_value
                        call    #show_long

'shlbyt
'------
'Shift byte in source left into destinarion

                        mov     fx,test_value
        if_never        muls    fx,#$bd 
                        call    #show_long

'shlnib
'-------
'Shift nibble in source left into destination
                        mov     fx,test_value
        if_never        enc     fx,#$c
                        call    #show_long

'allnib
'-------
'Fill destination with source nibble

                        mov     fx,#0
        if_never        ones   fx,#$a
                        call    #show_long

'TEST of group3b
'=======================================================================

'allbyt
'------
'Set all bytes in destination to source byte

                        mov     fx,test_value
        if_never        ror     fx,#$a5
                        call    #show_long

'getbyt
'------
'Get byte selected by user_reg in source

                        mov     cnt,#2  'select byte 2
        if_never        rol     fx,test_value
                        call    #show_long

'setbyt
'------
'Set byte selected by user_reg byte in destination to source byte
 
                        mov     fx,test_value
                        mov     cnt,#1   'select byte 1
        if_never        shr     fx,#$ee  'set byte to $EE
                        call    #show_long

'fastchk
'-------
'Returns a 4 bit pattern representing byte positions that match user_reg byte
 
                        mov     cnt,#$34  'byte to look for
        if_never        shl     fx,test_value
                        call    #show_long

'hits
'----
'Returns number of matches (hits) of user_reg byte in source long

                       mov     cnt,#$34  'byte to test for
        if_never        rcr     fx,test_value
                        call    #show_long

'ascbyte
'--------
'generates a 32 bit pattern representing 3 ascii characters.
'Includes start and stop bits and third character is a space.
                        
        if_never        rcl     ix,#$32 
                        mov     fx,ix
                        call    #show_long

                        mov     fx,ix
                        call    #send_pattern

                        mov     dx,#"*"
                        call    #send           'prove space character was sent                        
                        call    #newline

'decmod
'------
'Increment destination if no match, else zero destination
                        
                        mov     ix,#$22
        if_never        sar     ix,#$24          'incmod
                        mov     fx,ix
                        call    #show_long
                                                
        if_never        sar     ix,#$24          'incmod
                        mov     fx,ix
                        call    #show_long
                                                
        if_never        sar     ix,#$24          'incmod
                        mov     fx,ix
                        call    #show_long
                                                
here                    jmp     #here

'***************************************************************************

'Transmit 32 bit pattern (3 x ascii bytes with start/stop bits)

send_pattern            mov     cx,#32
                        mov     ax,cnt
                        add     ax,bit_delay
:loop                   test    fx,#1 wz
                        muxnz   outa,tx
                        waitcnt ax,bit_delay
                        shr     fx,#1
                        djnz    cx,#:loop
send_pattern_ret        ret

'**************************************************************************

'Send 8 ascii hex characters
                                      
show_long               mov       ex,#8
:loop                   rol       fx,#4
        if_never        mul     dx,fx           'n2a  nibble to ascii hex
                        call    #send                       
                        djnz      ex,#:loop
                        call    #newline
show_long_ret           ret              

'**************************************************************************                            

newline                 mov       dx,#13

'Transmit character in DX

send                    mov       cx,#10
                        or        dx,#$100
                        shl       dx,#1
                        mov       ax,cnt
                        add       ax,bit_delay
:loop                   waitcnt   ax,bit_delay
                        test      dx,#1 wz
                        muxnz     outa,tx
                        shr       dx,#1
                        djnz      cx,#:loop
newline_ret              
send_ret               ret

'*************************************************************************

'Assorted data and registers

test_value              long      $12345678

bit_delay               long      sys_clk / 1200                                          
_10secs                 long      sys_clk * 10              
tx                      long      |< tx_pin

ax                      res       1
bx                      res       1
cx                      res       1
dx                      res       1
ex                      res       1
fx                      res       1
gx                      res       1
hx                      res       1
ix                      res       1
                  